// &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
// &&&&&&&&  w h e n   t h e   c h i p s   a r e   d o w n &&&&&&&&&&&&&&&&&&&&&
// %%%%%%%%  - - - - - v o c o d e r - v e r s i o n - - - %%%%%%%%%%%%%%%%%%%%%
// &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
// &&&&&&&&&&&&&&&&&&&&&&&&&& code: Juan Manuel Escalante | www.realitat.com &&&
/*

 Version history:
 
 01 - Database parsing (main data and all individual titles) ! Huge step
 02 - Class making and orbits per category, titles per category
 03 - Speaking version via OSC04 - No voices this time
 */

//  - SWITCHES
Boolean feedback = true;
int titulosTotalesPerTopic = 50;
float anguloInicio = -45;
float anguloFinal =  270-45;
float orbitaMax = 600; // 600 original, parece funcionar 600 final
float orbitaMin = 60; // 1560 original 60 final
float centroX = (1280+4)/2;
float centroY = (720+4)/2;
Boolean titlesAzar = false;
float segundosTitlesAppearance = 4;
float segundosSpeakAppearanceDer = 3+0;
float segundosSpeakAppearanceIzq = 3+3.6;
float toleranciaAnguloPoblador = 5;
float friccionPobladores = 19;
Boolean pobladoresBoston = true;
Boolean pobladoresOsama = true;
float ruidoPobladoresMin = 0.00035;
float ruidoPobladoresMax = 0.015;
Boolean pobladores = true;
Boolean speakActivo = true;
Boolean automatizado = true;
Boolean voz = true;

// *
String stripeNameBoston = "gama7"; // png files for color data gama7.png is the one that worked
String stripeNameOsama = "gama7"; // png files for color data gama7.png is the one that worked
Boolean primeraVezTitles = true;
// Global vars (but relevant to keep track of)
int contador;
int cantidad; // How many orbits we'll have
int totalRows, totalCols, totales; // Basic basic global elements to know and keep track of
float noMayor, noMayorBoston, noMayorOsama;
float noMenor, noMenorBoston, noMenorOsama = 1500000;

// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------
void setup() {

  size(1280+4, 720+4); //720p resolution
  background(50); //Dark gray
  background(247); //Light gray

  // Load color and fonts data
  loadColors();
  loadFonts();

  // We load the data
  boston = dataParsing("Boston");
  osama = dataParsing("Osama");

  // WE load teh images
  cargarImagenes();

  // We initialize the data once the data is loaded
  iniciarDataViz();
  iniciarSpeak();
  smooth();
  frameRate(200);
}

// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------

void draw() {
//   scale(2);
  // translate(-320,-10);

  // A. Background actions
  background(247);

  // B. We show the Viz
  mostrarDataViz();

  // C. Auxiliary drawings and other icons
  mostrarAuxiliares(); // start and end lines, flash past present legends
  mostrarDayDivision(); //

  // D. Other functions and helpers
  calcularAnimGlobal();
  mouseInteraction();
  polvo();
  
  
  // E. SPEAK ! 
  if(speakActivo) speak();
  // -- The classic all-purpose counter
  contador++;
  
  
}
