
// ---------------------------------------------------------------
// -------------------- data parsing -----------------------------
// ---------------------------------------------------------------

Table tabla; 
// 
int [][] boston, osama;// All data will be hosted here
String [] headers; // All the headers will be located here.

String [][] titlesBoston;
String [][] titlesOsama; // We will store all of the titles here
int [] titlesTotalesOsama, titlesTotalesBoston; // 
int [] iteracionTitlesOsama, iteracionTitlesBoston; // So we know how many headers we have.
//
// -----------------------------------------------------------------------------------------------------------------
// Esta función va a encargarse de todos los datos a cargar --------------------------------------------------------
//
int[][] dataParsing(String tableName) {
  if (feedback) println(">> LOADING DATA: ON! ---> "+tableName);

  // We load the table, alright!
  tabla = new Table();
  if (tableName == "Boston") tabla = loadTable("data/databases/full/boston.csv");
  if (tableName == "Osama") tabla = loadTable("data/databases/full/osama.csv");

  // We set total rows and columnes (ignoring the first line) since all databases are the same, it really won't matter
  totalRows = tabla.getRowCount();
  totalCols = tabla.getColumnCount();

  // We load the headers (there will be only one type of headers). This is useful, to load the titles afterwards
  String [] headersT = new String[1];
  if (tableName == "Boston") headersT = loadStrings("data/databases/full/boston.csv");
  if (tableName == "Osama") headersT = loadStrings("data/databases/full/osama.csv");
  if (feedback) println(">> Temporary headers: "+headersT[0]); // Everything in this position is comma separated

  // We create the final headers array, Some feedback never hurts does it?
  headers = split( headersT[0], "," );
  if (feedback) println(">> 1st header: "+headers[0]);
  if (feedback) println(">> 2nd header: "+headers[1]);
  if (feedback) println(">> Last header: "+headers[headers.length-1]);

  // We load the titles and create the quantities array
  if (tableName == "Boston") {  
    titlesTotalesBoston = new int[headers.length];

    // We create the position of a current title iteration
    iteracionTitlesBoston = new int[headers.length];
    for (int i = 0; i < iteracionTitlesBoston.length; i++) {
      iteracionTitlesBoston[i] = 0;
    }

    titlesBoston = loadTitles(tableName, headers); // descomentar al final solo test
    // loadTitles(tableName, headers);
    if (feedback) println(" >> Boston title length: "+titlesBoston.length);
    if (feedback) println(" >> First Boston title: "+titlesBoston[1][1]);
    if (feedback) println(" >> First Boston title quantity: "+titlesTotalesBoston[1]);
  } else if (tableName == "Osama") {
    titlesTotalesOsama = new int[headers.length];
    titlesOsama = loadTitles(tableName, headers);

    // We create the position of a current title iteration
    iteracionTitlesOsama = new int[headers.length];
    for (int i = 0; i < iteracionTitlesOsama.length; i++) {
      iteracionTitlesOsama[i] = 0;
    }
  }

  // We set the total elements
  totales = (totalRows-1)*totalCols; // -1 por los headers, abusado!
  if (feedback) println(">> Elementos totales: "+totales);

  // We verify the data
  if (feedback) println(">> Tenemos "+totalRows+" rows.");
  if (feedback) println(">> Tenemos "+totalCols+" columns.");

  // We'll arrange everything into the dataMatrix
  //if(feedback) println(">> TABLE CONTENTS:");

  // We create the data Array to put everything inside
  int [][] dataMatrix = new int[totalRows][totalCols];

  // temporary variables for highest number
  float numeroMayor = 0;
  float numeroMenor = 500000;

  // We start sorting everythings
  for (int i = 0; i < totalRows; i++) {
    for (int j = 0; j < totalCols; j++) {

      int dato = tabla.getInt( i, j );
      // We place the values
      dataMatrix[i][j] = dato;

      // We verify highest and lowest number
      if ( numeroMenor >  dato && i > 0 && j > 0) numeroMenor = dato;
      if ( numeroMayor <  dato && i > 0 && j > 0) numeroMayor = dato;
      // Temporary output
      // if (feedback) println(">> R:"+i+" |C:"+j+" = "+ dato);
    }
  }

  // We check for the highest value locally and globally
  if (tableName == "Boston") {
    noMayorBoston = numeroMayor;
    noMenorBoston = numeroMenor;
  } else if (tableName == "Osama") {
    noMayorOsama = numeroMayor;
    noMenorOsama = numeroMenor;
  }

  // We set the global numbers for high and low value
  if (numeroMayor > noMayor) noMayor = numeroMayor;
  if (numeroMenor < noMenor) noMenor = numeroMenor;

  if (feedback && tableName == "Boston") println(">> Highest / Low found value Boston: "+noMayorBoston+" / "+noMenorBoston);
  if (feedback && tableName == "Osama") println(">> Highest / Low found value Osama: "+noMayorOsama+" / "+noMenorOsama);
  if (feedback) println(">> Global - Highest found value: "+numeroMayor);
  if (feedback) println(">> Global - Lowest found value: "+numeroMenor);


  //Note to self: all of the data will start in 0 position, no, can't remember to be honest.

  // We return the Array, finally
  return dataMatrix;
}

// -----------------------------------------------------------------------------------------------------------------
// We load all title data ------------------------------------------------------------------------------------------
//
String [][] loadTitles(String event, String [] encabezados) {
  //void loadTitles(String event, String [] encabezados) {

  // A. We create a local array
  String[][] localTitles= new String[encabezados.length][titulosTotalesPerTopic]; // No more than 50 items per category 

  // B. We proceed to load each title according to its own database
  //    We start from number 1, since the day is not really a title (1st column)
  for (int i = 1; i < encabezados.length; i++) {

    // 1. We get the route to load the specific title file
    String ruta = "data/databases/"+event+"_titles/"+encabezados[i]+".csv";
    if (feedback) println(">> >> "+event+" titles >> topic: "+encabezados[i]);

    // 2. Create a temporary storing Array for the title loaded
    String [] titulosTemaRaw = loadStrings(ruta);
    int longitud = titulosTemaRaw.length;
    if (feedback) println(" >> >> ... >> totalrawTitles = "+longitud);
    if (feedback) println(" >> >> ... >> pos[0] = "+titulosTemaRaw[0]);
    if (feedback && longitud > 1) println(" >> >> ... >> pos[1] = "+titulosTemaRaw[1]);
    if (feedback && longitud > 1) println(" >> >> ... >> last item = "+titulosTemaRaw[longitud-1]);

    // 3. We set the final length of this title
    if (event == "Boston") titlesTotalesBoston[i] = longitud;
    if (event == "Osama") titlesTotalesOsama[i] = longitud;

    // 4. We fill the local Titles Array
    for (int j = 1; j < titulosTotalesPerTopic && j < longitud; j++) {
      // 4-1 We store the split title
      String [] titulosTemaSplit = split(titulosTemaRaw[j], ",");

      // 4-2 We fill the data
      localTitles[i][j] = titulosTemaSplit[0];
      if (feedback) println(">> >> >> >> A colocar ind.titl: "+localTitles[i][j]);
    }
    // For ends next:
  }

  // C. We return the array
  return localTitles;
}
