// ------------------------------------------------------------
// -------------------- grales --------------------------------
// ----------------------------------------------------------------
// General functions that cannot be arranged in any other tab -----
// ----------------------------------------------------------------

// -------------------------------------------------------------------
// Loading the fonts
PFont numerosTotales;
PFont titles;
PFont roundTitles;
PFont roundTitlesAlias;
PFont speakFont;
void loadFonts() {

  titles = loadFont( "data/fonts/FuturaKoyu-48.vlw" ); 
  numerosTotales = loadFont( "data/fonts/FuturaDemiC-12.vlw" );
  roundTitles = loadFont("data/fonts/MyriadPro-Semibold-9.vlw");
  roundTitlesAlias = createFont("MyriadPro-Semibold", 9, true);
  speakFont = createFont("MyriadPro-Regular-9", 10, true);
}
// -------------------------------------------------------------------
// We load images we might use
//
PImage flashIcon, centerIcon, leyenda;
void cargarImagenes() {
  flashIcon = loadImage("data/images/full_flash_icon.png");
  centerIcon = loadImage("data/images/center_icon.png");
  leyenda = loadImage("data/images/leyendas.png");
}
// -------------------------------------------------------------------
// Helper lines and elements
// 

void mostrarAuxiliares() {
  // All will be on the center
  pushMatrix();
  translate(centroX, centroY);

  // First angle starting line
  stroke(0, 0, 0, 150* anim);
  strokeWeight(random(0.5, 0.6));
  pushMatrix();
  rotate(radians(anguloInicio));
  line(orbitaMin/2, 0, orbitaMax/2, 0);
  popMatrix();

  // Second angle starting line
  pushMatrix();
  rotate(radians(anguloFinal));
  line(orbitaMin/2, 0, orbitaMax/2, 0);
  popMatrix();

  // Middle 'attack line'
  stroke(255, 0, 0, 160* anim);
  strokeCap(SQUARE);
  strokeWeight( random(1.25, 1.3)*1 );
  pushMatrix();
  rotate(radians(90));
  line(orbitaMin/2, 0, orbitaMax/2, 0);
  fill(255, 0, 0, 160* anim);
  ellipseMode(CENTER);
  ellipse(orbitaMin/2, 0, 3, 3);
  ellipse(orbitaMax/2, 0, 3, 3);
  popMatrix();

  // We put the main attack/flash icon
  pushMatrix();
  rectMode(CENTER);
  translate(0, orbitaMax/2 -flashIcon.height/2);
  tint(255, 255, 255, 255*anim);
  image(flashIcon, -flashIcon.width/2 -2, 0);
  popMatrix();
  
   // WE put the center Icon
  image(centerIcon, -centerIcon.width/2, -centerIcon.height/2);
  
  

  popMatrix();
  
  // We put the legend
  float xLeyenda = 89;
  image(leyenda, xLeyenda, height/2-(leyenda.height/2));
  // The circles above the legend
  fill(0, 0, 0, 255*anim);
  strokeWeight(random(2));
  stroke(0, 0, 0, 255*anim);
  ellipse(xLeyenda +97, height/2 +16, 7, 7);
  fill(255, 0, 0, 255*anim);
  strokeWeight(random(2));
  stroke(255, 0, 0, 255*anim);
  ellipse(xLeyenda +97, height/2 -80, 7, 7);
}
// -------------------------------------------------------------------
// Day division lines
// 
void mostrarDayDivision() {
  float divisiones = 7+1+7; // The day of the event, 7 days earlier and seven after
  float anchoAngulo = (360-90)/(divisiones);
  for (int i = 0; i < divisiones; i++) {
    pushMatrix();
    translate(centroX, centroY);
    rotate(radians(anguloInicio));
    rotate(radians( anchoAngulo*(i+1) ));

    stroke(0, 0, 0, 130* anim);
    strokeWeight(random(0.3));

    line(orbitaMin/2 +13, 0, orbitaMax/2 -13, 0);

    popMatrix();
  }
}

// -------------------------------------------------------------------
// ANIM GLOBAL  (efecto animado de elementos globales)
// 
float anim = 0;
float velAnim = 0.00622;

void calcularAnimGlobal() { 
  anim += velAnim;
  if (anim >= 1) anim = 1;
}



// -------------------------------------------------------------------
// POLVO
// 

void polvo() {
  float cantidadPolvo = 5000;
  for ( int i = 0; i < cantidadPolvo; i++) {
    fill(0);
    stroke(0);
    strokeCap(ROUND);
    strokeWeight(random(0.8));
    point(random(width), random(height));
  }
}
